
#include <Servo.h>

Servo servoLeft;              // Left servo
Servo servoRight;             // Right servo

const int pingPin = 11;       // Ping connected to D11
unsigned int duration, inches, cm;

void setup() {
  servoLeft.attach(9);       // Left servo pin D9
  servoRight.attach(10);     // Right servo pin D10
}

void loop() {
  forward();                  // Drive forward
  
  // Read sonar to detect oncoming collision
  if(sonarRead() < 6) {       // Object ~5" or closer
    stopRobot();              // Stop, reverse, and turn
    delay(250);
    reverse();
    delay(500);
    turnRight();
    delay(750);
  }
  delay(5);
}

// Explore mode motion routines
void forward() {
  servoLeft.write(180);
  servoRight.write(0);
}
void reverse() {
  servoLeft.write(0);
  servoRight.write(180);
}
void turnRight() {
  servoLeft.write(180);
  servoRight.write(180);
}
void turnLeft() {
  servoLeft.write(0);
  servoRight.write(0);
}
void stopRobot() {
  servoLeft.write(90);
  servoRight.write(90);
}

// Read Ping ultrasonic sensor
int sonarRead () {
  pinMode(pingPin, OUTPUT);          // Set pin to OUTPUT
  digitalWrite(pingPin, LOW);        // Ensure pin is low
  delayMicroseconds(2);
  digitalWrite(pingPin, HIGH);       // Start ranging
  delayMicroseconds(5);              //   with 5 microsecond burst
  digitalWrite(pingPin, LOW);        // End ranging
  pinMode(pingPin, INPUT);           // Set pin to INPUT
  duration = pulseIn(pingPin, HIGH); // Read echo pulse
  inches = duration / 74 / 2;        // Convert to inches
  cm = duration / 29 / 2;            // Convert to centimeters
  return(inches);		     // Return inches (or cm)
}

